from datetime import datetime, timedelta
import random

def generate_weight_data(patient_id, initial_weight, height, creatinine_clearance, respiratory_freq, heart_freq, blood_type):
    # Constants for weight fluctuations
    MIN_WEIGHT_CHANGE = -0.5
    MAX_WEIGHT_CHANGE = 0.5

    # Date range for the year 2023
    start_date = datetime(2023, 1, 1)
    end_date = datetime(2023, 12, 31)
    current_date = start_date

    # List to store the generated data
    data = []

    # Generate data for each week
    while current_date <= end_date:
        # Realistic weight fluctuation based on patient information
        weight_change = random.uniform(MIN_WEIGHT_CHANGE, MAX_WEIGHT_CHANGE)
        weight_change *= (height / 170)  # Adjust weight change based on height
        weight_change *= (creatinine_clearance / 100)  # Adjust weight change based on creatinine clearance
        weight_change *= (respiratory_freq / 15)  # Adjust weight change based on respiratory frequency
        weight_change *= (heart_freq / 80)  # Adjust weight change based on heart frequency
        weight_change *= 1.1  # Scaling for a more noticeable change

        # Calculate the new weight
        new_weight = initial_weight + weight_change

        # Append data to the list
        data.append({
            'patient_id': patient_id,
            'weight': round(new_weight, 2),
            'date': current_date.strftime('%Y-%m-%d')
        })

        # Move to the next week
        current_date += timedelta(days=7)

    return data

patient_data_string = """1;73;156;107;14;88;B-
2;56;178;103;16;100;A+
3;82;156;76;20;79;B-
4;111;183;97;17;77;O+
5;64;179;84;18;97;A-
6;58;150;112;20;63;A+
7;101;196;100;16;82;B-
8;112;159;120;19;92;O+
9;59;176;83;20;64;AB+
10;56;191;66;18;79;O+
11;69;159;103;13;89;A-
12;69;154;74;13;88;A+
13;88;180;90;20;62;O-
14;60;200;61;15;63;A-
15;81;166;99;18;83;AB-
16;65;171;116;19;78;A-
17;103;189;120;15;64;A-
18;78;194;95;18;65;B+
19;116;175;80;17;99;AB+
20;98;191;118;19;98;A-
21;107;155;99;18;92;AB+
22;106;171;74;18;84;O-
23;88;193;101;13;89;B+
24;104;184;64;17;97;A-
25;89;174;100;18;95;A-
26;57;170;112;17;62;B+
27;62;190;89;16;88;B+
28;76;195;118;17;96;AB-
29;77;198;104;14;72;O-
30;83;181;79;19;80;AB+
31;60;184;101;13;98;B-
32;70;152;86;13;90;AB+
33;80;189;67;13;92;AB-
34;72;154;68;13;69;A-
35;120;165;62;18;63;O-
36;59;190;120;13;88;O-
37;70;193;62;17;66;AB+
38;50;168;79;14;81;O-
39;102;164;91;20;65;AB-
40;107;197;67;12;92;A-
41;110;155;66;20;71;A-
42;87;177;75;20;62;B-
43;54;156;116;17;75;AB+
44;79;198;94;13;88;A-
45;86;190;68;18;88;AB-
46;86;195;84;17;93;O-
47;108;156;89;18;93;B-
48;59;178;83;12;99;AB-
49;79;160;102;16;70;A-
50;83;194;120;16;83;O-
51;75;169;107;17;83;A+
52;104;151;104;13;78;O-
53;64;152;120;20;84;B+
54;119;170;94;15;86;B-
55;78;200;86;14;81;A+
56;69;153;97;19;98;A+
57;84;168;107;15;63;AB-
58;68;172;106;13;100;O+
59;59;173;69;17;81;B-
60;57;177;116;20;64;AB-
61;71;159;86;17;81;O+
62;89;165;101;13;66;B-
63;86;183;66;16;95;O-
64;106;176;113;15;84;AB+
65;65;186;91;18;78;A+
66;109;193;99;20;76;B-
67;88;200;86;20;98;O+
68;101;161;120;12;69;AB-
69;84;160;120;16;81;O+
70;114;161;77;12;65;AB-
71;119;155;62;14;97;B+
72;113;189;104;16;69;B+
73;106;174;83;16;82;O+
74;60;189;73;17;79;O+
75;55;193;88;17;85;AB-
76;105;165;88;12;68;A-
77;91;181;120;14;98;AB+
78;82;187;75;14;65;B-
79;53;159;114;18;79;B+
80;61;164;83;13;95;B+
81;79;179;66;14;84;B-
82;52;190;103;12;81;A-
83;84;166;83;13;68;AB-
84;55;179;94;20;93;B+
85;72;166;117;15;65;A-
86;110;192;101;18;87;O-
87;116;150;82;18;92;O-
88;106;179;63;19;83;A+
89;85;168;85;17;61;AB+
90;73;193;77;14;83;O-
91;105;184;72;17;79;AB+
92;112;160;67;16;71;B+
93;61;154;120;17;73;O+
94;110;178;114;13;81;A+
95;94;172;112;12;91;AB+
96;102;187;89;14;72;B-
97;92;169;65;14;74;B-
98;91;190;102;12;68;AB+
99;63;177;73;13;69;AB+
100;70;194;101;16;64;AB+
101;92;166;100;19;78;AB+
102;102;179;98;18;66;B+
103;113;169;61;19;92;B-
104;86;162;63;19;94;A+
105;101;174;110;18;93;A+
106;120;180;81;16;62;AB+
107;54;156;75;15;81;O+
108;108;165;68;20;99;O-
109;61;174;110;13;68;AB-
110;90;186;96;17;98;B-
111;82;172;73;18;84;AB-
112;91;186;64;13;69;A+
113;64;168;113;16;70;B-
114;101;194;108;19;71;O-
115;115;168;95;20;99;O+
116;50;151;73;16;70;AB+
117;119;192;97;12;88;AB-
118;109;175;73;15;62;AB-
119;102;167;112;18;86;B-
120;56;150;115;12;83;A-
121;74;186;74;12;75;B-
122;116;193;81;15;88;A-
123;96;199;109;16;99;O+
124;113;197;69;15;78;B+
125;106;153;110;14;88;A-
126;56;188;117;16;74;O-
127;76;197;98;16;94;B+
128;84;181;60;17;75;AB-
129;120;168;77;13;79;B+
130;66;199;114;12;90;O-
131;86;164;69;19;72;O-
132;106;188;68;18;83;O+
133;112;172;94;14;96;A-
134;65;164;76;14;88;O+
135;53;190;111;18;89;B-
136;80;162;71;20;78;A+
137;70;189;67;15;84;AB-
138;89;166;102;20;92;O-
139;120;193;115;20;93;A+
140;51;198;61;17;86;O+
141;120;196;68;13;70;AB-
142;102;199;60;18;72;O-
143;61;192;82;12;98;A-
144;78;193;110;18;68;A+
145;64;158;110;12;76;AB-
146;109;190;75;19;63;A-
147;65;156;97;13;90;O-
148;69;190;80;17;83;A+
149;113;191;61;18;95;A-
150;87;152;71;18;66;AB-
151;115;169;76;18;93;AB+
152;84;200;63;16;67;B-
153;103;178;68;13;78;A+
154;111;152;107;18;65;A+
155;110;187;86;12;70;AB-
156;81;173;93;17;77;O+
157;108;196;67;14;88;B-
158;120;158;107;19;92;AB+
159;68;155;64;17;69;O-
160;99;168;90;13;87;AB-
161;74;170;88;18;65;AB-
162;115;197;109;13;74;A-
163;67;176;83;15;88;AB+
164;58;161;92;18;82;O-
165;85;162;97;18;61;A-
166;103;158;66;20;86;AB+
167;93;200;88;13;63;A-
168;114;184;92;18;85;B-
169;84;173;74;16;92;B+
170;50;183;120;17;83;A+
171;86;182;99;15;75;B+
172;88;167;62;17;84;O-
173;112;160;106;14;65;O+
174;69;166;110;13;83;O+
175;107;180;118;20;74;O-
176;118;168;115;13;61;A+
177;111;197;102;20;80;B-
178;94;171;93;20;66;O-
179;92;157;79;15;81;AB+
180;120;179;89;17;69;O-
181;119;154;101;17;68;AB-
182;98;159;61;14;62;O+
183;108;198;63;15;78;B-
184;91;164;90;13;90;AB+
185;74;193;114;14;68;AB-
186;80;196;85;16;90;B-
187;99;193;87;15;88;AB-
188;79;175;103;14;99;AB-
189;102;185;66;14;60;AB+
190;55;173;91;13;65;O-
191;90;155;105;14;61;AB+
192;110;200;118;19;76;AB+
193;98;175;88;19;73;AB+
194;99;150;64;19;69;AB-
195;69;166;117;17;95;AB-
196;113;184;65;17;98;B+
197;54;157;80;14;93;AB-
198;66;179;98;19;87;B+
199;114;173;69;13;67;B+
200;92;193;64;19;78;A+"""


result = ""


for line in patient_data_string.splitlines():
    patient_data = line.split(";")
    patient_weights = generate_weight_data(int(patient_data[0]), int(patient_data[1]), int(patient_data[2]), int(patient_data[3]), int(patient_data[4]), int(patient_data[5]), patient_data[6])

    for entry in patient_weights:
        result += f"{entry['patient_id']};{entry['weight']};{entry['date']}\n"


file = open("connected_scales.csv", "w")
file.writelines(result)
file.close()
